/* eslint-disable no-unused-components */
<script lang="ts">
import Vue from 'vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getPageMetadata } from '../../common/meta';
import { CropInfinityHero, NextStep } from '~/components/common/index.vue';
import {
  ResourcesNextSteps,
  ResourcesStartHere,
  ResourcesFeaturedItems,
  ResourcesBrowser,
} from '~/components/resources/index.vue';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  name: 'ResourcesPage',
  components: {
    CropInfinityHero,
    ResourcesStartHere,
    ResourcesBrowser,
    ResourcesFeaturedItems,
    ResourcesNextSteps,
    NextStep,
  },
  nuxtI18n: false,
  async asyncData({ _ }: any) {
    try {
      const content = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'resources',
        include: 10,
      });

      const hero = {
        title: content.items[0].fields.pageContent[0].fields.title,
        subtitle: content.items[0].fields.pageContent[0].fields.description,
        primary_btn:
          content.items[0].fields.pageContent[0].fields.primaryCta.fields,
      };
      const metadata = {
        title: content.items[0].fields.seoMetadata[0].fields.ogTitle,
        ogTitle: content.items[0].fields.seoMetadata[0].fields.ogTitle,
        description: content.items[0].fields.seoMetadata[0].fields.description,
        ogDescription:
          content.items[0].fields.seoMetadata[0].fields.ogDescription,
        ogType: content.items[0].fields.seoMetadata[0].fields.ogType,
        ogUrl: content.items[0].fields.seoMetadata[0].fields.ogUrl,
        ogSiteName: content.items[0].fields.seoMetadata[0].fields.ogSiteName,
        ogImage: content.items[0].fields.seoMetadata[0].fields.ogImage,
      };

      const startHere = {
        title: content.items[0].fields.pageContent[1].fields.header,
        cards: content.items[0].fields.pageContent[1].fields.card,
      };

      const resources = {
        title: content.items[0].fields.schema.title,
        learn_more_text: content.items[0].fields.schema.learn_more_text,
        load_more_text: content.items[0].fields.schema.load_more_text,
        resources: content.items[0].fields.schema.resources,
      };

      const featuredResources = {
        title: content.items[0].fields.pageContent[2].fields.header,
        featured_card:
          content.items[0].fields.pageContent[2].fields.card[0].fields,
        cards: [
          content.items[0].fields.pageContent[2].fields.card[1].fields,
          content.items[0].fields.pageContent[2].fields.card[2].fields,
          content.items[0].fields.pageContent[2].fields.card[3].fields,
        ],
      };

      const nextCards = {
        title: content.items[0].fields.pageContent[3].fields.header,
        cards: [
          content.items[0].fields.pageContent[3].fields.card[0].fields,
          content.items[0].fields.pageContent[3].fields.card[1].fields,
          content.items[0].fields.pageContent[3].fields.card[2].fields,
        ],
      };

      return {
        hero,
        startHere,
        metadata,
        resources,
        featuredResources,
        nextCards,
      };
    } catch (error) {
      return {};
    }
  },
  head() {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
});
</script>
<template>
  <div>
    <CropInfinityHero :data="hero" />
    <ResourcesStartHere v-if="startHere" :data="startHere" />
    <ResourcesFeaturedItems
      v-if="featuredResources"
      :data="featuredResources"
    />
    <ResourcesBrowser v-if="resources" :data="resources" />
    <ResourcesNextSteps v-if="nextCards" :data="nextCards" />
    <SlpContainer>
      <NextStep disable-animations :variant="2" />
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss"></style>
